Contents

Table of Contents

Welcome to Code Chameleon, the extensible common-purpose editor supporting a multitude of programming and scripting languages. And if your language is not on the list, you can quickly and easily add its profile with syntax coloring, Intellisense/auto-complete, project management, and other properties.

Overview
Menus
Info Pane
Project Pane
Intellisense and auto-complete
Creating your own language profiles
Other products by C Point

Copyright © 2003 C Point. All rights reserved.
Revised: February 2003.

http://www.c-point.com

C Point
71 Williamson Road, Para Hills, Australia
Tel: +618 82633623
Fax: +618 83961477
Web: http://www.c-point.com
Email: c-point@c-point.com
Technical support: support@c-point.com


Overview

Code Chameleon is a powerful, extensible, and easy-to-use editor for programming, scripting and plain text files.
In short, here is what Chameleon has to offer:

  • Color-coded syntax for ActionScript, Active Server Pages (ASP), ADA, Apache, BASIC, batch files, C, C++, C#, Cascading Style Sheets (css), ColdFusion templates, Fortran, HTML, Java, JavaScript, Pascal, Perl script, PHP, SQL, TCL, and VB Script
  • Ability to experiment - unlimited Undo and Redo are only one click away
  • Bookmarking for easy navigation
  • Help as you type: Intellisense/Auto-complete eliminates the need to memorize standard functions, methods, properties and parameter lists
  • The brace matching - see the scope of the function or expression immediately
  • Code templates: you can insert any reusable piece of text into your document with the minimal number of keystrokes, or convert any piece of text to a template
  • Ability to automate code insertion and repetitive tasks, and provide macro-like capabilities via industry-standard Visual Basic for Applications (VBScript)
  • Single-click navigation between documents using document tabs
  • Find functions in your documents easily - they are automatically listed in the Functions tab
  • Ability to create your own language definitions and profiles
  • Create C#, Java and HTML projects using project templates, or create your own templates, and
  • Publish your creations on the Internet using built-in Quick FTP.

Where to go from here:
Menus
Info pane
Project pane
Intellisense
Creating your own language profiles
Other products by C Point

Please help us improve Code Chameleon by sending us your comments and suggestions to c-point@c-point.com.

Happy coding!
The C Point team
http://www.c-point.com


Menus

File

Edit

View

Insert

Options

Script
Html

C# Doc

Java Doc

Tools

Window
Help

Help


Intellisense/Auto-complete

Antechinus uses Intellisense® to simplify writing of code and make it more error-free. It works by monitoring your keystrokes and offering pick-lists with member functions, methods and properties, as shown below:

Use Intellisense to:

  • Speed up your work: pressing Enter when a pick-list item is highlighted will auto-complete the statement
  • Select the function or method from the list
  • Examine the methods that are available for the given class. Some classes, (e.g., String) have many methods and properties that are otherwise hard to remember, and
  • Examine the function declaration and its list of parameters.
Some points to keep in mind:

  • Some properties (e.g., screen.colorDepth) you can get, but not set. In this case, the property will be marked read-only.
  • Some methods may have optional parameters. The optional parameters are listed in square brackets, e.g., ArrayVar.slice(start, [end]);

This version of Code Chamelion supports Intellisense/auto-complete for C# programming language, and for JavaScript. To implement Intellisense for your own language profile see Creating your own language profiles.


Menus

Creating your own language profiles

Code Chameleon allows you to extend the environment by supplying your own language profiles. Follow these 6 steps to add a profile:

  • Step 1: Profile folder. Use Windows Explorer to open the Bin folder inside your Code Chameleon directory. Create a new folder that will hold the profile. For example, your folder can be "cpp" for the C++ language profile.
  • Step 2: File extensions and filters. Open Settings.ini in the Bin folder. In the [Extension] section, list all the file extensions that will use your folder, e.g.:

    [Extension]
    cpp=cpp
    h=cpp
    rc=cpp
    cxx=cpp

    At the end of the [Filter] section, add one or more filters to be used when opening files, e.g.:

    [Filter]
    ...
    20=C++ source files (.cpp; .rc; .cxx)|*.cpp; *.rc; *.cxx
    21=C++ header files (.h)|*.h
  • Step 3: Syntax. In your language profile folder, create Syntax.ini file and fill in the sections [Rules], [Functions], [Keywords], [Preprocessor], [Constants], and [User]. For an annotated example please see Syntax.ini in the Bin/cs folder.
  • Step 4: Icon and document template. For each of the file extensions, you need to supply an icon (.ico) file that will be used with File / New. Copy the icon file in the Bin / FileTypes folder and give it a meaningful name, e.g.:
    C++ file.ico
    If you do not have an icon editor, open the Icons folder in your Code Chameleon directory, and use one of the supplied icons.

    Create the document template file (e.g., Template.cpp) and place it in the Bin / FileTypes folder. This can be an empty file or any other text file that will be used to create a new document. Open Templates.ini and associate your icon with a template, e.g.:

    [Map]
    C++ file=Template.cpp

Your new language profile is complete.
As an advanced feature, Code Chameleon also allows you to add Intellisense/auto-complete to assist users while they are typing the code. When users type in the name of an object, property, or method that has been defined, Chameleon automatically pops up the relevant pick-lists to speed up the coding and eliminate the need to memorize parameter lists, methods, and properties. To see Intellisense in action, select File / New from the menu, and click on C# file. In your new C# document type the following lines of code to define a new String object:

String str = new String();
str.

Antechinus knows that an instance of a String object has been created and pops up the Intellisense pick-list:

  • Step 5: Intellisense/auto-complete (optional).
    • Create Autocomplete folder inside your language profile folder, e.g., Bin\cpp\Autocomplete.
    • In your Autocomplete folder create the Autocomplete.ini file. If your language uses object hierarchy (one object class is derived from another), you need to specify the relationship, e.g.:

      [Alias]
      Button=ButtonBase
      ButtonBase=RichControl
      RichControl=Control
      Control=Object
      For an annotated example, see Autocomplete.ini in the Bin\cs\Autocomplete folder.
    • In your Autocomplete folder, create an .ini file for each of the objects, e.g. (String.ini):
      [String]
      0=3,Copy,public static string Copy(string str);
      1=3,EndsWith,public bool EndsWith(string value);
      ..., where:

      "0", "1", etc. is the index of the item to list.
      "3" indicates a method. Use "1" for objects and "2" for properties.
      "Copy" is the text of the method displayed in the pick list.
      "public static string Copy(string str0);" is the tooltip displaying the complete method definition.
      Each entry has the following syntax:
      IndexNumber=EntryType,EntryListText,EntryDefinition[\nOverloadedParameters]
      For an annotated example, see String.ini in the Bin\cs\Autocomplete folder.
  • Step 6: Project type (optional). Chameleon also allows you to define different project types.
    • Create a folder for the new project type inside Bin\ProjectTypes folder, e.g., "C# Application".
    • Copy all the starter files comprising the project in your new project folder.
    • Create ProjectName.project in your new project folder, and set [Options] and [Files] sections.
      For an annotated example, see Bin\ProjectTypes\C# Application.
    • Create an icon (.ico) file to represent the project, and place it into the Bin\PrijectTypes folder. If you do not have an icon editor, open the Icons folder in your Code Chameleon directory, and use one of the supplied icons. Please note that the icon name must match the name of the project folder that it represents.


Other products

Other Products by C Point

To download the latest C Point applications, tutorials, and resources, please visit our Web site at:
http://www.c-point.com

Programming tools

  • Antechinus C# Editor . Utilize the power of .NET and create, compile and run C# applications from the integrated environment.
Graphics, animation, and Multimedia

  • Antechinus Draw Magic . Powerful flowcharting, diagramming, and drawing program with a vast set of extensible clipart libraries.
  • Antechinus Animator . Import images, add sounds, create AVI videos.
  • Antechinus Media Editor . Create AVI and MPEG animations and videos. Add sound to AVI and MPEG animations. Record Mp3 files. Try morphing...
Web development

  • Antechinus Web Effects . Develop interactive Web sites visually through a point-and-click interface, and publish your creation on the Internet. The new version includes Multimedia support, cross-browser menuing and automatic link checking.
  • Antechinus JavaScript Editor . This industry leader in JavaScript editing allows you to add JavaScript code to your HTML pages quickly and easily - giving your Web creations a real edge. Antechinus transforms your pages from displaying static content to live, dynamic, interactive applications.

Antechinus® is the registered trademark of C Point Pty Ltd.


The File menu

Check for News

Visits the C Point site for the latest news, tips, upgrades and tools. You must be connected to the Internet to use this option.

New

Creates a new document, or a new project. The supported programming and scripting languages are:

  • ActionScript
  • Active Server Pages (ASP)
  • ADA
  • Apache
  • BASIC
  • Batch files
  • C/C++
  • C#
  • Cascading Style Sheets (css)
  • ColdFusion templates
  • Fortran
  • HTML
  • Java
  • JavaScript
  • Pascal
  • Perl script
  • PHP
  • SQL
  • TCL, and
  • VBScript.

A project is a set of related files: source code, images, animations, and other resources. Chameleon-made project files have the extension .project.

Open

Opens an existing document.

Reload

Discards the changes you made to the document and reloads the last saved version.

Close

Closes the current document. Prompts to save changes if the document has been modified.
Close All
Closes all current document. Prompts to save changes if the document has been modified.

Save

Saves the current document.

Save As

Saves the document with a new name.

Save All

Saves all modified open files. Prompts you for the name and location of the document if it has not been saved before.

New Project
Creates a new project and allows you to add files to it.
Open Project
Opens an existing project.
Add Files to Project
Adds files to an open project.
Close Project
Closes the active project.
Open Workspace
Opens an existing workspace, comprising a project, files, and other tools that were active when the workspace was saved.
Save Workspace
Saves the current workspace to disk.
Close Workspace
Closes the current workspace.

Publish Using Quick FTP

Opens 1) the current document directory, and 2) Antechinus Quick FTP, allowing you to use drag-and-drop to publish your files on the Internet. For more details on using Quick FTP, please run the program and select Help / Manual from the menu.

Print

Sends the current document to the printer.

Print Preview

Opens the print preview dialog.

Print Setup

Allows you to change the printer and specify the printing options.

Recent File List

Allows you to open the documents from the Recent File List.

Exit

Closes Code Chameleon. Prompts to save changes if the document has been modified.


Edit menu

The Edit menu

Undo

Undoes the last editing action.

Redo

Redoes the last editing action.

Cut

Cuts the selected text and places it on the Clipboard.

Copy

Places the copy of the selected text on the Clipboard.

Paste

Inserts the text from the Clipboard into the document.

Toggle Bookmark

Bookmarks the line you are editing, displayed as the blue rounded rectangle. If the bookmark is already there, it will be cleared.

Clear Bookmark

Clears an already set bookmark.

Clear All Bookmarks

Removes all the bookmarks from the current document.

Go to Next Bookmark

Scrolls to the next bookmarked position.

Go to Previous Bookmark

Scrolls to the previous bookmarked position.

Go to Line

Scrolls to the line number that you specify.
Select All
Selects the entire document.

Change to Upper Case

Changes the selected text to upper case.

Change to Lower Case

Changes the selected text to lower case.

Search

Opens the Search dialog allowing you to specify the word or phrase to search for, and specify the search options. To find the next occurrence, press F3.

Replace

Opens the Replace dialog allowing you to replace one word or phrase with another one.

Go to Matching Brace

Positions the cursor to the brace matching the currently selected one, allowing you to see the scope of the function or expression. Before using this option select the brace, or place the cursor immediately before or after the brace.


View menu

The View menu

This menu allows you to show or hide the toolbars and panes used by the program. By default, all the toolbars and panes are visible. However, if you are working at low resolution (e.g., 640x480), you might wish to hide some of the toolbars and panes in order to have more space for editing.

Error Navigation
Code Chameleon allows you to add external tools using the Tools menu for the purpose of compiling and linking, and otherwise manipulating the documents. The output of a tool (e.g., a compiler) can be used to enable the error navigation. For detailed instructions, please refer to Tools menu.

ASCII Character Codes opens the table with the Dec/Hex codes for the ASCII characters.
View in Browser opens your document in the default Web browser. Use this option with .html, .htm, .asp, and other browser-supported files.
You can easily view your documents using different Web browsers - please see the Tools menu.


Operators menu

The Insert menu

Code Template

Code templates are reusable chunks of code which can greatly increase your speed of coding. You can insert a code template into your document in two ways:

  • Type the first few letters of the template and press Ctrl+Space. This will pop a list with all the matching templates - select one of them and press Enter, e.g.:

  • Or: select Insert / Code Template from the menu (or press Ctrl+T) to open the Code Templates dialog:

Type in the first few letters, or double-click the name of the template to insert it into your document.

Manage Code Templates

This option allows you to add new templates, or modify or delete the existing ones.

Tip: If you already have code templates stored in text files, you can just copy the files to the CodeTemplates directory.
Tip: To convert text from the current document into a code template, select the text and press Shift+Ctrl+T.

Date
Inserts the current date into the document.
Time
Inserts the current time into the document.
Date and Time
Inserts the current date and time into the document.

Color (Hex)
Opens the color dialog to allow you to select the color to be inserted into the document in the hexadecimal format. This format is most commonly used for Web pages.
Color (RGB)
Opens the color dialog to allow you to select the color to be inserted into the document in the RGB format. This format is commonly used in C/C++ and other programming languages.


Options menu

The Options menu

Settings

Opens the Settings dialog, allowing you to specify the fonts and colors for different syntax elements, and other options.

Save Files before Viewing

If this option is switched on, the program will prompt you to save the modified files before viewing them in the Web browser.

Intellisense/Auto-complete

Switches the Intellisense/Auto-complete feature on and off. By default, this option is on. However, switching this option off might speed up the editing on old and slow machines.
List Only Unique Properties/Methods
Directs the Intellisense not to list the base class properties and methods.
Word Wrap
Toggles word-wrapping in the active document on and off. Since Code Chameleon primary function is writing programming and scripting code, by default the word-wrap is off.


VBScript

The VBScript menu

Code Chameleon supports industry-standard Visual Basic Script for applications. This allows you to automate repetitive tasks (e.g., inserting blocks of code), and implement macro-like capabilities. This is done by accessing the document (Doc) and the application (App) objects. Please visit the Microsoft site for the VBScript user's guide and language reference. Please note that links on the Microsoft site change often - if the link provided no longer works, please go to www.microsoft.com and do a search on "VBScript".
The built-in VBScript editor automatically saves and loads the scripts to and from the Scripts folder. Also, color-coding and Intellisense/Auto-complete are fully supported.

VBScript is simple and is best learned by example. We suggest that you run the supplied sample scripts and examine the code.

  • To list all the available VBScript properties and methods, right-click anywhere in the editor to open the popup menu, and select List Properties/Methods.
  • The Doc object is an interface to the JavaScript editor: it allows you to examine the text, insert more text, and perform other operations. The Programmer.hbs file is an example of how to use the Doc object to select text and replace the selection or insert more text.
  • The App object is a limited interface to the Antechinus application: it allows you to open and save documents, change the size and position of the window, and use the timer. MovingWindow.hbs and SizeAndPos.hbs are examples of how to use the App object.
  • Try typing 'Doc.' to activate the Intellisense and see all the properties and methods belonging to the document object, or 'App.' for the application object.

Select

Loads an existing script for running or editing.

New

Creates the new VBScript.

Edit

Opens the VBScript editor to edit the selected script.

Run

Executes the selected VBScript.

Pause

Pauses the currently running VBScript.

Stop

Stops the currently running VBScript.


Html menu

The Html menu

The Html menu provides you with the text-based way of formatting Web pages. For more complex designs, we suggest combining Code Chameleon with one of the visual Web editors, such as Antechinus Web Effects, FrontPage, or Dreamweaver.


VBScript

C#Doc and JavaDoc menus

C# (C Sharp) and Java programming languages allow you to insert commands into your source code that are then used by the compiler to automatically produce the documentation. For instructions on how to use particular commands, please refer to your C# or Java manuals.


Tools menu

The Tools menu

This option allows you to add other applications to the menu and invoke them as needed. Most commonly, you would use this option to list all the Web browsers you wish to test the HTML code with, to add a visual Web editor such as Antechinus Web Effects , FrontPage, and add compilers, linkers, and other tools.
To add a new tool to the Tools menu:

  • Select Tools/Add & Edit Tools from the Tools menu
  • Click on the New button and type in the name of the tool to add
  • On the command line, type in the full path to the tool, or browse to it to select it (for example, c:\Windows\Notepad.exe)
  • Specify the arguments to pass to the tool when invoking it. For example, $(FilePath) will expand to the full path to the file you are currently editing, and
  • Click on the Update button to store the changes.

The new application has been added to the Tools menu. You can now close the Add & Edit Tools dialog, and call the application from the Tools menu.

You can parse the output that the new tool produces (e.g., a compiler) to provide automatic error navigation. To enable this functionality, do the following:

  • Select Add/Edit from the Tools menu and click on "New" to add an external tool to the list
  • Under "Command" provide the full path to the tool (e.g., for Java compiler: c:\jdk\bin\javac.exe)
  • Under "Arguments" select "$(FilePath)", which will expand to the full path to the active document, and provide other tool options
    (e.g., for Java compiler: -verbose)
  • Under "Initial directory" select $(FileDir) if the document directory should be used
  • Tick the "Use output window" option. Please note that this option is for command-line tools, not for programs with Windows GUI.
  • Tick the "Use error-parsing VBScript", and
  • Click on "Edit VBScript" to write the VBScript code that will parse the output received when you run the tool. Code Chameleon supports industry-standard VBScript for Applications . Please visit the Microsoft site for the VBScript user's guide and language reference. Please note that links on the Microsoft site change often - if the link provided no longer works, please go to www.microsoft.com and do a search on "VBScript".

Select "Tools / Add & Edit Tools / Java compiler" from the menu for an example of using VBScript to parse the output for the compilation errors. To add an error to the list, use:
App.AddError ( FileName, OutputLineIndex, LineIndex, CharacterIndex ), where:

  • FileName is the the name of the file being compiled.
  • OutputLineIndex is the index of the line being parsed. This information (if present) is used to navigate to the error when the user double-clicks the line in the Build pane. If this information is not present, the only way to locate the errors in code is by clicking on one of the error-navigation buttons on the Script Toolbar.
  • LineIndex is the line index in the file FileName where the error occurred.
  • CharacterIndex, if present, denotes the position of the error within the line of code.


Window menu

The Window menu

The Window menu provides you with the standard mechanism of arranging the document windows and switching between the documents.
To maximize the editing space, we suggest that you always work with maximized windows and use the single-click document tabs for switching between documents.


Help menu

The Help menu

Manual

Opens the manual (this file).

Check for News

Visits the C Point site for the latest news, tips, upgrades, and tools.
Developer solutions
Takes you to the latest tools, tutorials, and resources for software developers on the C Point site.
Join Monthly Creative C-lutions Bulletin
Allows you to subscribe to the monthly Creative C-lutions Bulletin.
Join Discussion Forum
Takes you to the Discussion Forums where you can participate in discussions and share your knowledge and experience with others.
Send us an Email
This options opens your default email client, so you could send your comments and suggestions to us. Please help us make Code Chameleon a better product.

C Point Website

Takes you to the C Point Web site, the authors of Code Chameleon. Here you can download additional resources and applications, join the discussion board, and get the latest developers' news.

About Code Chameleon

Displays the program information, version number and copyright.


Info pane

The Info pane

The Info pane has only one tab, Build, which is used to display the output from external tools defined with the "Use output window" option checked. Right-click inside the Build tab to bring the popup menu with the following options:

  • Copy. This copies the selection from the Build window to the Clipboard.
  • Copy All. This copies the content of the entire Build window to the Clipboard.
  • Clear. This clears the contents of the Build window.

You can parse the output that the tool produces (e.g., a compiler) to provide automatic error navigation. For instructions on how to use this option, see the Tools menu.


Project pane

The Project pane

The project pane has only one tab, Files, which lists all the files that belong to a project. Double-clicking any of the files in the File tab will open it in the editor. You can also right-click a file to popup a menu with the following options:

  • Open in Editor. This option opens the selected file in the editor (same as double-clicking the file).
  • Open in Native Application. This opens the selected file using the native application for this file extension. For example, opening a .jpg or a .gif file might open Paint Shop Pro, opening a .txt file might open the Notepad, etc.
  • Remove from project. This option removes the entry from the project, but does not delete the file from disk.
  • Delete this file. This option removes the entry from the project, and deletes the file from disk.